﻿
using System;
using HeuristicLab.Algorithms.GraphRouting;
using HeuristicLab.Problems.RoutePlanning.Osm.Data;
namespace HeuristicLab.Problems.RoutePlanning.Test {
  class Program {
    static void Main(string[] args) {
      Test1();
    }

    private static void Test1() {
      string filepath = @"..\..\OsmTestFiles\test_mid.osm";

      Console.Write("Loading data ... ");
      XmlDataSource xmlDs = new XmlDataSource(filepath);
      Console.WriteLine("done.");

      Graph.Graph graph = new Graph.Graph(xmlDs);
      IRouter router = new DijkstraAlgorithm(graph);

      Console.Write("Calculate route ... ");
      long[] result = router.Calculate(529102170, 1001363194);
      System.Console.WriteLine("done.");

      Console.Write("Result: ");
      foreach (long i in result) System.Console.Write(i + "; ");
      Console.WriteLine();
      System.Console.Read();
    }

    private static void Test2() {
      //string filepath = @"..\..\OsmTestFiles\test.osm";
      //string filepath = @"..\..\OsmTestFiles\testNode1.osm";
      //string filepath = @"..\..\OsmTestFiles\testWay1.osm";
      //string filepath = @"..\..\OsmTestFiles\testRelation1.osm";
      string filepath = @"..\..\OsmTestFiles\test_mid.osm";

      Console.Write("Loading data ... ");
      XmlDataSource xmlDs = new XmlDataSource(filepath);
      Console.WriteLine("done.");

      Graph.Graph graph = new Graph.Graph(xmlDs);
      IRouter router = new DijkstraAlgorithm(graph);

      Console.Write("Calculate route ... ");
      long[] result = router.Calculate(529102170, 1001363194);
      System.Console.WriteLine("done.");

      Console.Write("Result: ");
      foreach (long i in result) System.Console.Write(i + "; ");
      Console.WriteLine();
      System.Console.Read();
    }
  }
}
